Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

Main Page | Modules | Namespace List | Class Hierarchy | Class List | Namespace Members | Class Members | Related Pages

# openvrml::mfstring Class Reference
[Field Values]

Inheritance diagram for openvrml::mfstring:

[legend]
List of all members.

## Detailed Description

A string array node field value.

Model of
  FieldValue

## Public Types

typedef std::vector< std::string > | value_type
| Type of value.

## Public Member Functions

| mfstring (std::vector< std::string >::size_type n=0, const std::string &value=std::string()) throw (std::bad_alloc)
| Construct.
| mfstring (const std::vector< std::string > &value) throw (std::bad_alloc)
| Construct.
template<typename InputIterator>
| mfstring (InputIterator first, InputIterator last)
| Create an mfstring with a copy of a range.
virtual | ~mfstring () throw ()
| Destroy.
virtual std::auto_ptr< field_value > | clone () const throw (std::bad_alloc)
| Virtual copy constructor.
virtual field_value & | assign (const field_value &value) throw (std::bad_cast, std::bad_alloc)
| Virtual assignment.
virtual type_id | type () const throw ()
| Get the field_value::type_id associated with this class.

## Public Attributes

std::vector< std::string > | value
| String values.

## Private Member Functions

virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfstring &lhs, const mfstring &rhs) throw()
| Compare for equality.
bool | operator!= (const mfstring &lhs, const mfstring &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfstring &a, openvrml::mfstring &b)
| Swap the values of `a` and `b`.

## Member Typedef Documentation

openvrml::mfstring::value_type

| Type of value.

## Constructor & Destructor Documentation

openvrml::mfstring::mfstring | ( | std::vector< std::string >::size_type | n = `0`,
|  | const std::string & | value = `std::string()`
| ) | throw (std::bad_alloc)`[explicit]`

Construct.

Creates an mfstring with `n` copies of `value`.

Parameters:

  | n | the number elements in mfstring::value.
  | value | used to initialize mfstring::value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Postcondition:
  `mfstring::value.size()` is `n`. Every element in mfstring::value is a copy of `value`.

openvrml::mfstring::mfstring | ( | const std::vector< std::string > & | value | ) | throw (std::bad_alloc)`[explicit]`

Construct.

Parameters:

  | value | initial value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

template<typename InputIterator>
openvrml::mfstring::mfstring | ( | InputIterator | first,
|  | InputIterator | last
| ) |

Create an mfstring with a copy of a range.

Creates an mfstring with a value that is a copy of the range [`first`, `last`).

Parameters:

  | first | an iterator pointing to the beginning of the range.
  | last | an iterator pointing one past the end of the range.

openvrml::mfstring::~mfstring | ( |  | ) | throw ()`[virtual]`

| Destroy. Each of the mfstring's elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

std::auto_ptr< field_value > openvrml::mfstring::clone | ( |  | ) | const throw (std::bad_alloc)`[virtual]`

Virtual copy constructor.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

field_value & openvrml::mfstring::assign | ( | const field_value & | value | ) | throw (std::bad_cast, std::bad_alloc)`[virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an mfstring object.
  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

field_value::type_id openvrml::mfstring::type | ( |  | ) | const throw ()`[virtual]`

Get the field_value::type_id associated with this class.

Returns:
  `field_value::mfstring_id`.

Implements openvrml::field_value.

void openvrml::mfstring::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfstring & | lhs,
|  | const mfstring & | rhs
| ) | throw()`[related]`

Compare for equality.

Parameters:

  | lhs | left-hand operand.
  | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfstring & | lhs,
|  | const mfstring & | rhs
| ) | throw()`[related]`

Compare for inequality.

Parameters:

  | lhs | left-hand operand.
  | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfstring & | a,
|  | openvrml::mfstring & | b
| ) | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  | a |
  | b |

## Member Data Documentation

std::vector< std::string > openvrml::mfstring::value

| String values.